#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/swap.h>

void show_mem(void)
{
#ifndef CONFIG_NEED_MULTIPLE_NODES  /* XXX(hch): later.. */
	int pfn, total = 0, reserved = 0;
	int shared = 0, cached = 0;
	int highmem = 0;
	struct page *page;

	printk("Mem-info:\n");
	show_free_areas();
	printk("Free swap:       %6ldkB\n", nr_swap_pages<<(PAGE_SHIFT-10));
	pfn = max_mapnr;
    printk("max_mapnr=%lu\n", max_mapnr);
	while (pfn-- > 0) {
#if defined(CONFIG_MIPS_OHIO) 
        if(pfn < (CONFIG_MIPS_OHIO_PHY_MEMSTART >> PAGE_SHIFT))
            continue;
#elif defined(CONFIG_MIPS_AR7)
        if(pfn < (CONFIG_MIPS_AR7_PHY_MEMSTART >> PAGE_SHIFT))
            continue;
#elif defined(CONFIG_MIPS_UR8)
        if(pfn < (CONFIG_MIPS_UR8_PHY_MEMSTART >> PAGE_SHIFT))
            continue;
#endif /*--- #ifdef CONFIG_MIPS_OHIO ---*/
		page = pfn_to_page(pfn);
#if defined(CONFIG_MIPS_OHIO) 
        if((0x1FFFFFFFUL & (unsigned long)page) < CONFIG_MIPS_OHIO_PHY_MEMSTART)
            continue;
#elif defined(CONFIG_MIPS_AR7)
        if((0x1FFFFFFFUL & (unsigned long)page) < CONFIG_MIPS_AR7_PHY_MEMSTART)
            continue;
#elif defined(CONFIG_MIPS_UR8)
        if((0x1FFFFFFFUL & (unsigned long)page) < CONFIG_MIPS_UR8_PHY_MEMSTART)
            continue;
#endif /*--- #ifdef CONFIG_MIPS_OHIO ---*/
		total++;
		if (PageHighMem(page))
			highmem++;
		if (PageReserved(page))
			reserved++;
		else if (PageSwapCache(page))
			cached++;
		else if (page_count(page))
			shared += page_count(page) - 1;
	}
	printk("%d pages of RAM\n", total);
	printk("%d pages of HIGHMEM\n",highmem);
	printk("%d reserved pages\n",reserved);
	printk("%d pages shared\n",shared);
	printk("%d pages swap cached\n",cached);
#endif
}
